]> git.ipfire.org Git - thirdparty/git.git/blame - git-bisect.sh
Merge branch 'maint'
[thirdparty/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
243a60fb
CC
3USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4LONG_USAGE='git bisect help
5 print this long help message.
6git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
38a47fd6
CC
7 reset bisect state and start bisection.
8git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
6ca8b977
CC
12git bisect skip [<rev>...]
13 mark <rev>... untestable revisions.
38a47fd6
CC
14git bisect next
15 find next bisection to test and check it out.
16git bisect reset [<branch>]
17 finish bisection search and go back to branch.
18git bisect visualize
19 show bisect status in gitk.
20git bisect replay <logfile>
21 replay bisection log.
22git bisect log
23 show bisect log.
24git bisect run <cmd>...
243a60fb
CC
25 use <cmd>... to automatically bisect.
26
27Please use "git help bisect" to get the full man page.'
d025524d 28
8f321a39 29OPTIONS_SPEC=
ae2b0f15 30. git-sh-setup
4c550686 31require_work_tree
8cc6a083 32
ce32660e
JS
33_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35
e9a45d75 36sq() {
d9bffc08 37 @@PERL@@ -e '
e9a45d75
JH
38 for (@ARGV) {
39 s/'\''/'\'\\\\\'\''/g;
40 print " '\''$_'\''";
41 }
42 print "\n";
43 ' "$@"
44}
45
8cc6a083 46bisect_autostart() {
823ea121 47 test -s "$GIT_DIR/BISECT_START" || {
8cc6a083
LT
48 echo >&2 'You need to start by "git bisect start"'
49 if test -t 0
50 then
51 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
52 read yesno
53 case "$yesno" in
54 [Nn]*)
55 exit ;;
56 esac
57 bisect_start
58 else
59 exit 1
60 fi
61 }
62}
63
64bisect_start() {
8cc6a083 65 #
634f2464 66 # Verify HEAD.
8cc6a083 67 #
48949a18 68 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e
JS
69 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
70 die "Bad HEAD - I need a HEAD"
634f2464 71
ee831f7d 72 #
634f2464 73 # Check if we are bisecting.
ee831f7d 74 #
d3e54c88 75 start_head=''
634f2464
CC
76 if test -s "$GIT_DIR/BISECT_START"
77 then
78 # Reset to the rev from where we started.
9d0cd91c
CC
79 start_head=$(cat "$GIT_DIR/BISECT_START")
80 git checkout "$start_head" || exit
634f2464
CC
81 else
82 # Get rev from where we start.
83 case "$head" in
84 refs/heads/*|$_x40)
85 # This error message should only be triggered by
86 # cogito usage, and cogito users should understand
87 # it relates to cg-seek.
88 [ -s "$GIT_DIR/head-name" ] &&
89 die "won't bisect on seeked tree"
90 start_head="${head#refs/heads/}"
91 ;;
92 *)
93 die "Bad HEAD - strange symbolic ref"
94 ;;
95 esac
96 fi
8cc6a083
LT
97
98 #
634f2464 99 # Get rid of any old bisect state.
8cc6a083 100 #
823ea121 101 bisect_clean_state || exit
38a47fd6
CC
102
103 #
104 # Check for one bad and then some good revisions.
105 #
106 has_double_dash=0
107 for arg; do
108 case "$arg" in --) has_double_dash=1; break ;; esac
109 done
110 orig_args=$(sq "$@")
111 bad_seen=0
d3e54c88 112 eval=''
38a47fd6
CC
113 while [ $# -gt 0 ]; do
114 arg="$1"
115 case "$arg" in
116 --)
8fe26f44 117 shift
38a47fd6
CC
118 break
119 ;;
120 *)
634f2464 121 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
38a47fd6
CC
122 test $has_double_dash -eq 1 &&
123 die "'$arg' does not appear to be a valid revision"
124 break
125 }
737c74ee
CC
126 case $bad_seen in
127 0) state='bad' ; bad_seen=1 ;;
128 *) state='good' ;;
129 esac
d3e54c88 130 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
8fe26f44 131 shift
38a47fd6
CC
132 ;;
133 esac
8fe26f44 134 done
38a47fd6 135
ba963de8
CC
136 #
137 # Change state.
138 # In case of mistaken revs or checkout error, or signals received,
139 # "bisect_auto_next" below may exit or misbehave.
140 # We have to trap this to be able to clean up using
141 # "bisect_clean_state".
142 #
143 trap 'bisect_clean_state' 0
144 trap 'exit 255' 1 2 3 15
145
146 #
147 # Write new start state.
148 #
ba963de8 149 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
823ea121 150 sq "$@" >"$GIT_DIR/BISECT_NAMES" &&
ba963de8 151 eval "$eval" &&
6c98c054 152 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
ba963de8
CC
153 #
154 # Check if we can proceed to the next bisect state.
155 #
38a47fd6 156 bisect_auto_next
ba963de8
CC
157
158 trap '-' 0
8cc6a083
LT
159}
160
55624f9a
CC
161bisect_write() {
162 state="$1"
163 rev="$2"
737c74ee 164 nolog="$3"
55624f9a
CC
165 case "$state" in
166 bad) tag="$state" ;;
167 good|skip) tag="$state"-"$rev" ;;
168 *) die "Bad bisect_write argument: $state" ;;
169 esac
ba963de8 170 git update-ref "refs/bisect/$tag" "$rev" || exit
f454cdc4 171 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
6c98c054 172 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
173}
174
c9c4e2d5
CC
175is_expected_rev() {
176 test -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
177 test "$1" = $(cat "$GIT_DIR/BISECT_EXPECTED_REV")
178}
179
180mark_expected_rev() {
181 echo "$1" > "$GIT_DIR/BISECT_EXPECTED_REV"
182}
183
184check_expected_revs() {
185 for _rev in "$@"; do
186 if ! is_expected_rev "$_rev"; then
187 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK"
188 rm -f "$GIT_DIR/BISECT_EXPECTED_REV"
189 return
190 fi
191 done
192}
193
155fc795 194bisect_state() {
8cc6a083 195 bisect_autostart
155fc795
CC
196 state=$1
197 case "$#,$state" in
198 0,*)
199 die "Please call 'bisect_state' with at least one argument." ;;
200 1,bad|1,good|1,skip)
201 rev=$(git rev-parse --verify HEAD) ||
202 die "Bad rev input: HEAD"
c9c4e2d5
CC
203 bisect_write "$state" "$rev"
204 check_expected_revs "$rev" ;;
e3389075 205 2,bad|*,good|*,skip)
155fc795 206 shift
d3e54c88 207 eval=''
e3389075 208 for rev in "$@"
155fc795 209 do
a179a303 210 sha=$(git rev-parse --verify "$rev^{commit}") ||
e3389075 211 die "Bad rev input: $rev"
d3e54c88
CC
212 eval="$eval bisect_write '$state' '$sha'; "
213 done
c9c4e2d5
CC
214 eval "$eval"
215 check_expected_revs "$@" ;;
e3389075
CC
216 *,bad)
217 die "'git bisect bad' can take only one argument." ;;
cc9f24d0
JH
218 *)
219 usage ;;
8cc6a083 220 esac
97e1c51e
CC
221 bisect_auto_next
222}
223
8cc6a083 224bisect_next_check() {
0a5280a9
JH
225 missing_good= missing_bad=
226 git show-ref -q --verify refs/bisect/bad || missing_bad=t
227 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
6fecf191 228
0a5280a9
JH
229 case "$missing_good,$missing_bad,$1" in
230 ,,*)
231 : have both good and bad - ok
232 ;;
233 *,)
234 # do not have both but not asked to fail - just report.
235 false
236 ;;
237 t,,good)
238 # have bad but not good. we could bisect although
239 # this is less optimum.
240 echo >&2 'Warning: bisecting only with a bad commit.'
241 if test -t 0
242 then
243 printf >&2 'Are you sure [Y/n]? '
e5d3afd7
FM
244 read yesno
245 case "$yesno" in [Nn]*) exit 1 ;; esac
0a5280a9
JH
246 fi
247 : bisect without good...
248 ;;
8cc6a083 249 *)
0a5280a9 250 THEN=''
823ea121 251 test -s "$GIT_DIR/BISECT_START" || {
0a5280a9
JH
252 echo >&2 'You need to start by "git bisect start".'
253 THEN='then '
254 }
255 echo >&2 'You '$THEN'need to give me at least one good' \
256 'and one bad revisions.'
257 echo >&2 '(You can use "git bisect bad" and' \
258 '"git bisect good" for that.)'
259 exit 1 ;;
8cc6a083
LT
260 esac
261}
262
263bisect_auto_next() {
434d036f 264 bisect_next_check && bisect_next || :
8cc6a083
LT
265}
266
97e1c51e
CC
267filter_skipped() {
268 _eval="$1"
269 _skip="$2"
270
271 if [ -z "$_skip" ]; then
f821d089 272 eval "$_eval"
97e1c51e
CC
273 return
274 fi
275
276 # Let's parse the output of:
277 # "git rev-list --bisect-vars --bisect-all ..."
f821d089 278 eval "$_eval" | while read hash line
97e1c51e
CC
279 do
280 case "$VARS,$FOUND,$TRIED,$hash" in
281 # We display some vars.
282 1,*,*,*) echo "$hash $line" ;;
283
284 # Split line.
285 ,*,*,---*) ;;
286
287 # We had nothing to search.
288 ,,,bisect_rev*)
289 echo "bisect_rev="
290 VARS=1
291 ;;
292
293 # We did not find a good bisect rev.
294 # This should happen only if the "bad"
295 # commit is also a "skip" commit.
296 ,,*,bisect_rev*)
297 echo "bisect_rev=$TRIED"
298 VARS=1
299 ;;
300
301 # We are searching.
302 ,,*,*)
303 TRIED="${TRIED:+$TRIED|}$hash"
304 case "$_skip" in
305 *$hash*) ;;
306 *)
307 echo "bisect_rev=$hash"
308 echo "bisect_tried=\"$TRIED\""
309 FOUND=1
310 ;;
311 esac
312 ;;
313
314 # We have already found a rev to be tested.
315 ,1,*,bisect_rev*) VARS=1 ;;
316 ,1,*,*) ;;
317
318 # ???
319 *) die "filter_skipped error " \
320 "VARS: '$VARS' " \
321 "FOUND: '$FOUND' " \
322 "TRIED: '$TRIED' " \
323 "hash: '$hash' " \
324 "line: '$line'"
325 ;;
326 esac
327 done
328}
329
330exit_if_skipped_commits () {
331 _tried=$1
332 if expr "$_tried" : ".*[|].*" > /dev/null ; then
333 echo "There are only 'skip'ped commit left to test."
334 echo "The first bad commit could be any of:"
e23cb8c0 335 echo "$_tried" | tr '[|]' '[\012]'
97e1c51e
CC
336 echo "We cannot bisect more!"
337 exit 2
338 fi
339}
340
f821d089
CC
341bisect_checkout() {
342 _rev="$1"
343 _msg="$2"
344 echo "Bisecting: $_msg"
c9c4e2d5 345 mark_expected_rev "$_rev"
f821d089
CC
346 git checkout -q "$_rev" || exit
347 git show-branch "$_rev"
348}
349
350is_among() {
351 _rev="$1"
352 _list="$2"
353 case "$_list" in *$_rev*) return 0 ;; esac
354 return 1
355}
356
f821d089
CC
357handle_bad_merge_base() {
358 _badmb="$1"
359 _good="$2"
c9c4e2d5 360 if is_expected_rev "$_badmb"; then
f821d089
CC
361 cat >&2 <<EOF
362The merge base $_badmb is bad.
363This means the bug has been fixed between $_badmb and [$_good].
364EOF
365 exit 3
366 else
367 cat >&2 <<EOF
368Some good revs are not ancestor of the bad rev.
369git bisect cannot work properly in this case.
370Maybe you mistake good and bad revs?
371EOF
372 exit 1
373 fi
374}
375
376handle_skipped_merge_base() {
377 _mb="$1"
378 _bad="$2"
379 _good="$3"
380 cat >&2 <<EOF
381Warning: the merge base between $_bad and [$_good] must be skipped.
382So we cannot be sure the first bad commit is between $_mb and $_bad.
383We continue anyway.
384EOF
385}
386
6a54d976
CC
387#
388# "check_merge_bases" checks that merge bases are not "bad".
389#
390# - If one is "good", that's good, we have nothing to do.
391# - If one is "bad", it means the user assumed something wrong
392# and we must exit.
393# - If one is "skipped", we can't know but we should warn.
394# - If we don't know, we should check it out and ask the user to test.
395#
396# In the last case we will return 1, and otherwise 0.
397#
f821d089
CC
398check_merge_bases() {
399 _bad="$1"
400 _good="$2"
401 _skip="$3"
402 for _mb in $(git merge-base --all $_bad $_good)
403 do
404 if is_among "$_mb" "$_good"; then
405 continue
406 elif test "$_mb" = "$_bad"; then
407 handle_bad_merge_base "$_bad" "$_good"
408 elif is_among "$_mb" "$_skip"; then
409 handle_skipped_merge_base "$_mb" "$_bad" "$_good"
410 else
f821d089 411 bisect_checkout "$_mb" "a merge base must be tested"
6a54d976 412 return 1
f821d089
CC
413 fi
414 done
6a54d976 415 return 0
f821d089
CC
416}
417
6a54d976
CC
418#
419# "check_good_are_ancestors_of_bad" checks that all "good" revs are
420# ancestor of the "bad" rev.
421#
422# If that's not the case, we need to check the merge bases.
423# If a merge base must be tested by the user we return 1 and
424# otherwise 0.
425#
f821d089 426check_good_are_ancestors_of_bad() {
c9c4e2d5
CC
427 test -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
428 return
429
f821d089
CC
430 _bad="$1"
431 _good=$(echo $2 | sed -e 's/\^//g')
432 _skip="$3"
433
434 # Bisecting with no good rev is ok
435 test -z "$_good" && return
436
437 _side=$(git rev-list $_good ^$_bad)
438 if test -n "$_side"; then
6a54d976 439 # Return if a checkout was done
c9c4e2d5 440 check_merge_bases "$_bad" "$_good" "$_skip" || return
f821d089 441 fi
c9c4e2d5
CC
442
443 : > "$GIT_DIR/BISECT_ANCESTORS_OK"
6a54d976
CC
444
445 return 0
f821d089
CC
446}
447
8cc6a083 448bisect_next() {
8fe26f44 449 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 450 bisect_autostart
0a5280a9
JH
451 bisect_next_check good
452
f821d089
CC
453 # Get bad, good and skipped revs
454 bad=$(git rev-parse --verify refs/bisect/bad) &&
455 good=$(git for-each-ref --format='^%(objectname)' \
456 "refs/bisect/good-*" | tr '\012' ' ') &&
97e1c51e 457 skip=$(git for-each-ref --format='%(objectname)' \
d2d188d9 458 "refs/bisect/skip-*" | tr '\012' ' ') || exit
97e1c51e 459
f821d089 460 # Maybe some merge bases must be tested first
6a54d976
CC
461 check_good_are_ancestors_of_bad "$bad" "$good" "$skip"
462 # Return now if a checkout has already been done
463 test "$?" -eq "1" && return
f821d089
CC
464
465 # Get bisection information
97e1c51e
CC
466 BISECT_OPT=''
467 test -n "$skip" && BISECT_OPT='--bisect-all'
97e1c51e 468 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
0a5280a9 469 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
97e1c51e 470 eval=$(filter_skipped "$eval" "$skip") &&
0a5280a9
JH
471 eval "$eval" || exit
472
473 if [ -z "$bisect_rev" ]; then
474 echo "$bad was both good and bad"
475 exit 1
670f5fe3 476 fi
0a5280a9 477 if [ "$bisect_rev" = "$bad" ]; then
97e1c51e 478 exit_if_skipped_commits "$bisect_tried"
0a5280a9 479 echo "$bisect_rev is first bad commit"
5be60078 480 git diff-tree --pretty $bisect_rev
0a5280a9 481 exit 0
8cc6a083 482 fi
0a5280a9 483
97e1c51e
CC
484 # We should exit here only if the "bad"
485 # commit is also a "skip" commit (see above).
486 exit_if_skipped_commits "$bisect_rev"
487
f821d089 488 bisect_checkout "$bisect_rev" "$bisect_nr revisions left to test after this"
8cc6a083
LT
489}
490
cc9f24d0
JH
491bisect_visualize() {
492 bisect_next_check fail
235997c9
JH
493
494 if test $# = 0
495 then
508e84a7 496 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
235997c9 497 '') set git log ;;
508e84a7 498 set*) set gitk ;;
235997c9
JH
499 esac
500 else
501 case "$1" in
502 git*|tig) ;;
503 -*) set git log "$@" ;;
504 *) set git "$@" ;;
505 esac
506 fi
507
e3f062bf 508 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
235997c9 509 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
510}
511
8cc6a083 512bisect_reset() {
823ea121 513 test -s "$GIT_DIR/BISECT_START" || {
fce0499f
CC
514 echo "We are not bisecting."
515 return
516 }
8cc6a083 517 case "$#" in
823ea121 518 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
737c74ee
CC
519 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
520 die "$1 does not seem to be a valid branch"
8cc6a083 521 branch="$1" ;;
8fe26f44 522 *)
8cc6a083
LT
523 usage ;;
524 esac
9d0cd91c 525 git checkout "$branch" && bisect_clean_state
e204de28
JH
526}
527
38a47fd6 528bisect_clean_state() {
947a604b 529 # There may be some refs packed during bisection.
634f2464 530 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
947a604b
CC
531 while read ref hash
532 do
823ea121 533 git update-ref -d $ref $hash || exit
947a604b 534 done
c9c4e2d5
CC
535 rm -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
536 rm -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
823ea121
CC
537 rm -f "$GIT_DIR/BISECT_LOG" &&
538 rm -f "$GIT_DIR/BISECT_NAMES" &&
539 rm -f "$GIT_DIR/BISECT_RUN" &&
9d0cd91c 540 # Cleanup head-name if it got left by an old version of git-bisect
823ea121
CC
541 rm -f "$GIT_DIR/head-name" &&
542
543 rm -f "$GIT_DIR/BISECT_START"
38a47fd6
CC
544}
545
e204de28 546bisect_replay () {
737c74ee 547 test -r "$1" || die "cannot read $1 for replaying"
e204de28 548 bisect_reset
6c98c054 549 while read git bisect command rev
e204de28 550 do
6c98c054
MV
551 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
552 if test "$git" = "git-bisect"; then
553 rev="$command"
554 command="$bisect"
555 fi
e204de28
JH
556 case "$command" in
557 start)
e9a45d75 558 cmd="bisect_start $rev"
737c74ee
CC
559 eval "$cmd" ;;
560 good|bad|skip)
561 bisect_write "$command" "$rev" ;;
e204de28 562 *)
737c74ee 563 die "?? what are you talking about?" ;;
e204de28
JH
564 esac
565 done <"$1"
566 bisect_auto_next
8cc6a083
LT
567}
568
a17c4101 569bisect_run () {
83020120
CC
570 bisect_next_check fail
571
a17c4101
CC
572 while true
573 do
574 echo "running $@"
575 "$@"
576 res=$?
577
578 # Check for really bad run error.
579 if [ $res -lt 0 -o $res -ge 128 ]; then
580 echo >&2 "bisect run failed:"
581 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
582 exit $res
583 fi
584
155fc795 585 # Find current state depending on run success or failure.
71b0251c
CC
586 # A special exit code of 125 means cannot test.
587 if [ $res -eq 125 ]; then
588 state='skip'
589 elif [ $res -gt 0 ]; then
155fc795 590 state='bad'
a17c4101 591 else
155fc795 592 state='good'
a17c4101
CC
593 fi
594
155fc795
CC
595 # We have to use a subshell because "bisect_state" can exit.
596 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
a17c4101
CC
597 res=$?
598
599 cat "$GIT_DIR/BISECT_RUN"
600
71b0251c
CC
601 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
602 > /dev/null; then
603 echo >&2 "bisect run cannot continue any more"
604 exit $res
605 fi
606
a17c4101
CC
607 if [ $res -ne 0 ]; then
608 echo >&2 "bisect run failed:"
155fc795 609 echo >&2 "'bisect_state $state' exited with error code $res"
a17c4101
CC
610 exit $res
611 fi
612
613 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
614 echo "bisect run success"
615 exit 0;
616 fi
617
618 done
619}
620
621
8cc6a083
LT
622case "$#" in
6230)
624 usage ;;
625*)
626 cmd="$1"
627 shift
628 case "$cmd" in
243a60fb
CC
629 help)
630 git bisect -h ;;
8cc6a083
LT
631 start)
632 bisect_start "$@" ;;
155fc795
CC
633 bad|good|skip)
634 bisect_state "$cmd" "$@" ;;
8cc6a083
LT
635 next)
636 # Not sure we want "next" at the UI level anymore.
637 bisect_next "$@" ;;
235997c9 638 visualize|view)
cc9f24d0 639 bisect_visualize "$@" ;;
8cc6a083
LT
640 reset)
641 bisect_reset "$@" ;;
e204de28
JH
642 replay)
643 bisect_replay "$@" ;;
644 log)
645 cat "$GIT_DIR/BISECT_LOG" ;;
a17c4101
CC
646 run)
647 bisect_run "$@" ;;
8cc6a083
LT
648 *)
649 usage ;;
650 esac
651esac